// AMConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AMConfig.h"
#include "AMConfigDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString g_VarFile;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAMConfigDlg dialog

CAMConfigDlg::CAMConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAMConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAMConfigDlg)
	m_Duration = 0;
	m_Welcome = _T("");
	m_Rings = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAMConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAMConfigDlg)
	DDX_Text(pDX, IDC_EDIT_DURATION, m_Duration);
	DDX_Text(pDX, IDC_EDIT_MESSAGE, m_Welcome);
	DDX_Text(pDX, IDC_EDIT_RINGS, m_Rings);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAMConfigDlg, CDialog)
	//{{AFX_MSG_MAP(CAMConfigDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAMConfigDlg message handlers

BOOL CAMConfigDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	
	LoadConfig(g_VarFile);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAMConfigDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAMConfigDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAMConfigDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAMConfigDlg::LoadConfig(CString CmdFile)
{
	//$RingCount
	//$Welcome
	//$Duration

	try {
		int pos;
		CString str;
		CStdioFile xfile(CmdFile,CFile::modeRead);

		while(xfile.ReadString(str)) {
			pos = str.Find("$RingCount") ;
			if(pos != -1) {
				str = str.Mid(pos+strlen("$RingCount"));
				str.TrimLeft();
				str.TrimRight();
				m_Rings = atoi(str);
				continue;
			}
			pos = str.Find("$Welcome");
			if(pos != -1) {
				str = str.Mid(pos+strlen("$Welcome"));
				str.TrimLeft();
				str.TrimRight();
				m_Welcome = str;
				continue;
			}
			pos = str.Find("$Duration");
			if(pos != -1) {
				str = str.Mid(pos+strlen("$Duration"));
				str.TrimLeft();
				str.TrimRight();
				m_Duration = atoi(str);
				continue;
			}
		}
		UpdateData(FALSE);
	}
	catch(CFileException* e) {
		e->Delete();
	}
}


void CAMConfigDlg::SaveConfig(CString CmdFile)
{
	//$RingCount
	//$Welcome
	//$Duration

	try {
		CString str;
		CStdioFile xfile(CmdFile,CFile::modeCreate|CFile::modeWrite);

		str.Format("$RingCount %d\n",m_Rings);
		xfile.WriteString(str);

		str.Format("$Welcome %s\n",m_Welcome);
		xfile.WriteString(str);

		str.Format("$Duration %d\n",m_Duration);
		xfile.WriteString(str);
		xfile.Close();
	}
	catch(CFileException* e) {
		e->Delete();
	}
}

void CAMConfigDlg::OnOK() 
{
	UpdateData();
	SaveConfig(g_VarFile);
	CDialog::OnOK();
}

